package nl.amis.sales.crm;

import com.oracle.bpel.client.Locator;
import com.oracle.bpel.client.NormalizedMessage;
import com.oracle.bpel.client.ServerException;
import com.oracle.bpel.client.delivery.IDeliveryService;

import org.w3c.dom.Element;

import com.oracle.bpel.client.Locator;
import com.oracle.bpel.client.util.WhereCondition;


import java.io.IOException;

import java.rmi.RemoteException;

import java.util.HashMap;
import java.util.Hashtable;
import java.util.List;
import java.util.Map;

import javax.naming.Context;

import oracle.tip.pc.api.worklist.IWorklistContext;
import oracle.tip.pc.api.worklist.IWorklistService;
import oracle.tip.pc.api.worklist.IWorklistTask;
import oracle.tip.pc.services.hw.task.ITask;
import oracle.tip.pc.api.worklist.WorklistServiceException;
import oracle.tip.pc.api.worklist.payload.Form;
import oracle.tip.pc.api.worklist.payload.PayloadFormGenerator;

import oracle.tip.pc.services.hw.task.impl.Task;
import oracle.tip.pc.services.hw.worklist.RemoteWorklistServiceClient;

import org.w3c.dom.Element;


public class DealNegotiatorClient {
    public DealNegotiatorClient() {
    }

    /** see: http://www.huihoo.com/oracle/docs/B14099_19/integrate.1012/b14448/worklist.htm#BHABGEHG
 */
    public static void main(String[] args) throws ServerException, Exception, 
                                                  WorklistServiceException {
        DealNegotiatorClient dealNegotiatorClient = new DealNegotiatorClient();
        // Set JNDI Properties for remote invocation ( will work for local also... 
        // 1. get a handle to the remove worklist service client
        RemoteWorklistServiceClient client = new RemoteWorklistServiceClient();

        // 2. set approver's user and password
        try {
             // note: method client.init() uses the files pc.properties and hw_worklist_jndi.properties
             // the latter file specifies the RMI server where the worklist service can be reached as well as the credentials to be used
             // the first file sets a number of configuration values for the WorkflowService
            client.init();
        } catch (WorklistServiceException e) {
            e.printStackTrace();
        }
        String user = "jstein";
        String password = "welcome";
        System.out.println("Connecting to WorklistService as " + user);

        // 3. get worklist context for user
        IWorklistContext ctx = null;
        try {
            ctx = client.authenticateUser(user, password);
        } catch (WorklistServiceException e) {
            // TODO
            e.printStackTrace();
        }
        System.out.println("Got Worklist Context");

        // 4. set filters for retrieving My tasks with Assigned status
        Map filterMap = new HashMap();

        filterMap.put(IWorklistService.FILTER_TYPE_TASK_FILTER, 
                      IWorklistService.TASK_FILTER_MY);
        filterMap.put(IWorklistService.FILTER_TYPE_STATUS_FILTER, 
                      IWorklistService.STATUS_FILTER_ASSIGNED);

        List tasks = 
            client.getWorklistTasks(ctx, filterMap, IWorklistService.SORT_FIELD_TASK_TITLE, 
                                    IWorklistService.SORT_ORDER_ASCENDING);
        if (tasks != null) {
            for (int i = 0; i < tasks.size(); i++) {
                Task task = (Task)tasks.get(i);
                String taskId = task.getTaskId();
                System.out.println(task.getTitle());
                

                Element payload = (Element)task.getPayload();
                float totalPrice = Float.parseFloat((payload.getNodeValue()));
                // automatically award another 13% discount
                totalPrice = (float)(totalPrice * 0.87);
                payload.setNodeValue(Float.toString(totalPrice));
                client.updateTask(ctx, task);
                // add some comments to the task 
                client.appendTaskComments(ctx, taskId, 
                                          "Programmatically manipulated by nl.amis.sales.crm.DealNegotiatorClient on " + 
                                          new java.util.Date()+  ". New total price set at  " +Float.toString(totalPrice));
                                          System.out.println( 
                                          "Programmatically manipulated by nl.amis.sales.crm.DealNegotiatorClient on " + 
                                          new java.util.Date()+  ". New total price set at  " +Float.toString(totalPrice));
                // close the task by setting its status to DONE
                client.customTaskOperation(ctx, taskId, "DONE");
            }

        }
    }
}
